<?php
# ******************************
# General Information Section
# ******************************
#$directory = "/tmp/pooch"; 

# ******************************
# Pooch Node Information Section
# ******************************

# Get job data
$original_data = `/usr/local/bin/poochstat -j -r`;
$data_here = strlen($original_data);

# Check if data was collected and refresh if not
if ($data_here <= 15)
{
sleep(5);
$original_data = `/usr/local/bin/poochstat -j -r`;
}

#var_dump($data);

$titles = array("ame:", "state:", "job id:", "process id:", "start time:date", "submission time:date" , "end time:date", "elapsed time:", "origin:", "target subfolder:", "job type:", "tasks per computer:", "retrieve output:", "launch failure queues job:", "BUSY check:", "automatically acquire nodes:", "node count:", "file count:");
$title_quantity = count($titles);
#var_dump($title_quantity);

$display_titles = array("Name", "State", "Job id", "Process id", "Start time", "Submission time" , "End time", "Elapsed time", "Origin", "Target subfolder", "Job type", "Tasks per computer", "Retrieve output", "Launch failure queues job", "BUSY check", "Automatically acquire nodes", "Node count", "File count");

# take off curly brackets
$original_data = rtrim($original_data, "}\n");
#var_dump($original_data);
# determine length of original data string
$stringlength = strlen($original_data);
# remove curly brackets from the beginning of the data string
$trimmed_data = substr($original_data, 2, $stringlength-1); 
#var_dump($trimmed_data);
# Remove origin name because of using name: as string in first title item
$trimmed_data = str_replace("origin:{name:", "origin:{", $trimmed_data);
# remove titles
#$trimmed_data = str_replace($titles, "", $trimmed_data);
#var_dump($trimmed_data);
# remove additional quote markings
$trimmed_data = str_replace("\"", "", $trimmed_data);
#var_dump($trimmed_data);
# split into individual node details
$data_array = explode("}, {", $trimmed_data);
#var_dump($data_array);
# determine number of items in data_array
$job_quantity = count($data_array);

# separate by comma - each node data
for ($count = 0; $count<$job_quantity; $count++) {
$job_data[$count] = explode(",",$data_array[$count]);
}


$title_display = "";
$job_display = "";
	#$title_display = $title_display."<div style=\"width:850;height:600;overflow:auto;\">";
	$title_display = $title_display."<table width=100% border=1><tr>";
	for ($count = 0; $count<$title_quantity; $count++) {
	$title_display = $title_display."<td><font size=1>$display_titles[$count]</font></td>";
	}
	$title_display = $title_display."</tr>";
	for ($job_count = 0; $job_count<$job_quantity; $job_count++) {		
		$job_display = $job_display."<tr>";
		for ($title_count=0; $title_count<$title_quantity; $title_count++) {
			$data_status = "missing";
			$data_quantity = count($job_data[$job_count]);
			for ($data_count=0; $data_count<$data_quantity; $data_count++) {
				if (($title_count == 0) && (strpos($job_data[$job_count][$data_count],$titles[0]) != false)) {
					#var_dump($title_count);
					$job_data[$job_count][$data_count] = str_replace("name:", "", $job_data[$job_count][$data_count]);
					$print_current_variable = $job_data[$job_count][$data_count];
					$job_display = $job_display."<td align=center><font size=1>$print_current_variable</font></td>";
					$data_status = "here";				
				} elseif (($title_count == 4) && (strpos($job_data[$job_count][$data_count],$titles[4]) != false)) {
					#var_dump($title_count);
					$job_data[$job_count][$data_count] = str_replace($titles[4], "", $job_data[$job_count][$data_count]);
					$print_current_variable = $job_data[$job_count][$data_count]." ".$job_data[$job_count][$data_count+1].",".$job_data[$job_count][$data_count+2];
					$job_display = $job_display."<td align=center><font size=1>$print_current_variable</font></td>";
					$data_count = $data_count + 2;
					$data_status = "here";
				} elseif (($title_count == 5) && (strpos($job_data[$job_count][$data_count],$titles[5]) != false)) {
					#var_dump($title_count);
					$job_data[$job_count][$data_count] = str_replace($titles[5], "", $job_data[$job_count][$data_count]);
					$print_current_variable = $job_data[$job_count][$data_count]." ".$job_data[$job_count][$data_count+1].",".$job_data[$job_count][$data_count+2];
					$job_display = $job_display."<td align=center><font size=1>$print_current_variable</font></td>";
					$data_count = $data_count + 2;
					$data_status = "here";
				} elseif (($title_count == 6) && (strpos($job_data[$job_count][$data_count],$titles[6]) != false)) {
					#var_dump($title_count);
					$job_data[$job_count][$data_count] = str_replace($titles[6], "", $job_data[$job_count][$data_count]);			
					$print_current_variable = $job_data[$job_count][$data_count]." ".$job_data[$job_count][$data_count+1].",".$job_data[$job_count][$data_count+2];
					$job_display = $job_display."<td align=center><font size=1>$print_current_variable</font></td>";
					$data_count = $data_count + 2;
					$data_status = "here";
				} elseif (($title_count == 8) && (strpos($job_data[$job_count][$data_count],$titles[8]) != false)) {
					#var_dump($title_count);
					$job_data[$job_count][$data_count] = str_replace($titles[8], "", $job_data[$job_count][$data_count]);
					$print_current_variable = $job_data[$job_count][$data_count]." ".$job_data[$job_count][$data_count+1];
					$job_display = $job_display."<td align=center><font size=1>$print_current_variable</font></td>";
					$data_count++;
					$data_status = "here";
				} elseif (strpos($job_data[$job_count][$data_count],$titles[$title_count]) != false) {
					#var_dump($title_count);
					$job_data[$job_count][$data_count] = str_replace($titles[$title_count], "", $job_data[$job_count][$data_count]);
					$print_current_variable = $job_data[$job_count][$data_count];
					$job_display = $job_display."<td align=center><font size=1>$print_current_variable</font></td>";
					$data_status = "here";
				}
			}
			if ($data_status == "missing") {
			$job_display = $job_display."<td align=center><BR></td>";
			}
		}
	$job_display = $job_display."</tr>";
	}
	$job_display = $job_display."</table>";
	#$job_display = $job_display."</div>";		

# ******************************
# Diagnostic Section
# ******************************
#var_dump($HTTP_POST_VARS);

?>

<html>
<head>
  <title>Pooch HTML Interface</title>                              
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
</head>
<body>
<table align="center" bgcolor="#999999" width="900" border="0" cellspacing="0" cellpadding="0">
			<tbody>
				<tr>
					<td align="center" width="850" valign="middle">
						<table cellpadding="0" cellspacing="0" border="0" width="90%">
							<tr>
								<td valign="top" colspan=3>
									<div align="center">
										<b><font size="+1">Job Status Window</font></b></div>
								</td>
							</tr>
							<FORM ACTION="job-status.php" METHOD="post">
								<tr><td width="290" bgcolor="#c0c0c0"><b>Job Listing</b></td>
								<td bgcolor="#c0c0c0"><div align="center"><INPUT TYPE="submit" NAME="Refresh Job Information" VALUE="Refresh Status Information"></div></td><input type="hidden" name="page_refresh" value="Yes"></FORM>	
							<FORM ACTION="job-interface.php" METHOD="post">
								<td bgcolor="#c0c0c0"><div align="center"><INPUT TYPE="submit" NAME="job_interface" VALUE="Return to Job Interface"></div></td>
							</FORM></tr>
				<tr>
						<td valign="top" bgcolor="#ffffff" colspan=3><font size="-3"><?PHP
print "$title_display";
print "<br>";
print "$job_display";
?></font></td>
					
				</tr>
						<FORM ACTION="job-status.php" METHOD="post">
								<tr><td width="290" bgcolor="#c0c0c0"><b>Job Listing</b></td>
								<td bgcolor="#c0c0c0"><div align="center"><INPUT TYPE="submit" NAME="Refresh Job Information" VALUE="Refresh Status Information"></div></td><input type="hidden" name="page_refresh" value="Yes"></FORM>	
							<FORM ACTION="job-interface.php" METHOD="post">
								<td bgcolor="#c0c0c0"><div align="center"><INPUT TYPE="submit" NAME="job_interface" VALUE="Return to Job Interface"></div></td>
							</FORM></tr>
			</tbody>
		</table>
	</body>
</html>

